QGIS Application - Bug report #10956
QgsSnapper crash/freeze/issues
2014-07-26 03:48 AM - Matthias Kuhn

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Digitising

Affected QGIS version:2.4.0 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 19304
Description

Executing the following python code and then clicking the map canvas works on QGIS 2.2.

On QGIS 2.4 it needs to be adapted, so a new snapper gets created in the callback to restore functionality (Minor issue as the
workaround is backwards compatible).

At the same time, a warning gets printed to the log about deprecation of .mapRenderer() and a suggestion to use .mapSettings() instead.
If this is done

- QGIS 2.4 freezes
- QGIS 2.5 (master) crashes (sometimes) in the crs transformation code and never returns any snapped points

also when moving the snapper instantiation to the callback there are no snapping results.

Code working in 2.2 but no longer in 2.4

from qgis.gui import QgsMapToolEmitPoint
from PyQt4.QtCore import QPoint

| = iface.activeLayer()

sl = QgsSnapper.SnaplLayer()

sl.mLayer =1

sl.mTolerance = 10

sl.mUnitType = QgsTolerance.Pixels

sl.mSnapTo = QgsSnapper.SnapToVertex

s = QgsSnapper( iface.mapCanvas().mapRenderer() )
s.setSnapLayers( [sl] )

mt = QgsMapToolEmitPoint( iface.mapCanvas() )

def canvasclicked( mpt, e ):
# transform map to device coordinate
dpt = iface.mapCanvas().getCoordinate Transform().transform( mpt )
(_, sp) = s.snapPoint( QPoint( dpt.x(), dpt.y() ) )
print '{} points found'.format( len(sp ) )

mt.canvasClicked.connect( canvasclicked )
iface.mapCanvas().setMapTool( mt)

QGIS 2.4 deprecation adapted code: no snhapping results are found

from qgis.gui import QgsMapToolEmitPoint
from PyQt4.QtCore import QPoint
| = iface.activeLayer()
mt = QgsMapToolEmitPoint( iface.mapCanvas() )

def canvasclicked( mpt, e ):
sl = QgsSnapper.SnaplLayer()
sl.mLayer = |
sl.mTolerance = 10
sl.mUnitType = QgsTolerance.Pixels
sl.mSnapTo = QgsSnapper.SnapToVertex
s = QgsSnapper( iface.mapCanvas().mapSettings() )
s.setSnapLayers( [sl] )
# transform map to device coordinate

dpt = iface.mapCanvas().getCoordinate Transform().transform( mpt )

(_, sp) = s.snapPoint( QPoint( dpt.x(), dpt.y() ) )
print '{} points found'.format( len(sp ) )

mt.canvasClicked.connect( canvasclicked )
iface.mapCanvas().setMapTool( mt)

Associated revisions

Revision 43c4cd72 - 2014-10-20 07:06 PM - Martin Dobias

Fix #10956 (QgsSnapper crash/freeze/issues)

QgsMapSettings instance of QgsMapCanvas may have been prematurely deleted by SIP.
The KeepReference annotation will force QgsMapCanvas wrapper to keep one more ref

to it, so its reference count will not go to zero while map canvas is still alive.

History

#1 - 2014-07-28 07:49 AM - Giovanni Manghi
- Priority changed from Normal to Severe/Regression

#2 - 2014-08-30 10:22 AM - Jiirgen Fischer
- Category set to Digitising

#3 - 2014-10-20 10:07 AM - Martin Dobias

- Status changed from Open to Closed

Fixed in changeset commit:"43c4cd72ada19e9293a0c881ee5fb42acab74cc7".

#4 - 2014-10-20 10:11 AM - Martin Dobias

Btw. the code with QgsMapRenderer works for me with master...
